----------------------------------------------------------------------------------
-- Company:    Nabla Designs s.l.
-- Engineer:   F.T. / J.T.T.
-- 
-- Create Date:     September 14th 2011 
-- Design Name: 
-- Module Name:    digit_board_rev0 - Behavioral 
-- Project Name: 
-- Target Devices: SIMPlugIN LX45 board - Spartan 6 LX45 -2 
-- Tool versions: ISE 12.4
-- Description: exercises seven segment display and swithc of SIMPlugIN-IGIT board when connected in CON3 of SIMPlugIN-LX45 base board
--
-- Dependencies: 
--
-- Revision: 
-- Revision 1.0 - first realease
-- Additional Comments: 
--  Refer to SIMPlugIN-LX45 and SIMPlugIN-DIGIT user manual

-- FUNCTIONALITY
--   * the four positions of the switch are reflected in the four user leds in sIMPlugIN-LX45 base board
--   * both hex digit are incremente 0,1,..,F folowed only the decimal point lit and the the cycle repeats.



----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity digit_board_rev0 is
Port ( 
	CLK_25MHZ											: in 		std_logic;
	RESET_POW_ON									: in 		std_logic;

	LED1_N											: out 	std_logic; -- user LED1 of SIMPlugIN-LX45 board 
	LED2_N                                 : out 	std_logic; -- user LED2  
	LED3_N                                 : out 	std_logic; -- user LED3  
	LED4_N                                 : out 	std_logic; -- user LED4  


      con3_05 : out  STD_LOGIC ;
      con3_06 : out  STD_LOGIC ;
      con3_07 : out  STD_LOGIC ;
      con3_08 : out  STD_LOGIC ;
      con3_11 : out  STD_LOGIC ;
      con3_12 : out  STD_LOGIC ;
      con3_13 : out  STD_LOGIC ;
      con3_14 : out  STD_LOGIC ;
      con3_17 : out  STD_LOGIC ;
      con3_18 : out  STD_LOGIC ;
      con3_19 : out  STD_LOGIC ;
      con3_20 : out  STD_LOGIC ;
      con3_23 : out  STD_LOGIC ;
      con3_24 : out  STD_LOGIC ;
      con3_25 : out  STD_LOGIC ;
      con3_26 : out  STD_LOGIC ;
      con3_29 : in   STD_LOGIC ;
      con3_30 : in   STD_LOGIC ;
      con3_31 : in   STD_LOGIC ;
      con3_32 : in   STD_LOGIC 



-- The following pins are NOT used in the present project
-- ======================================================

--CLK_user : in   STD_LOGIC ;   -- optional user clock. Not used in this project

--      push_buttom_1_n  : in   STD_LOGIC ;  -- onboard user pushbutton 1
--      push_buttom_2_n  : in   STD_LOGIC ;  -- onboard user pushbutton 2
--      push_buttom_3_n  : in   STD_LOGIC ;  -- onboard user pushbutton 3
--      push_buttom_4_n  : in   STD_LOGIC ;  -- onboard user pushbutton 4



--      switch_1_n      : in   STD_LOGIC ; -- onboard user switch - position 1
--      switch_2_n      : in   STD_LOGIC ; -- onboard user switch - position 2
--      switch_3_n      : in   STD_LOGIC ; -- onboard user switch - position 3
--      switch_4_n      : in   STD_LOGIC ; -- onboard user switch - position 4

--      CONSOLE_CTS_N       : in  STD_LOGIC ;  -- console CTS (fpga in)
--      CONSOLE_RTS_N       : out STD_LOGIC ;  -- console RTS (fpga out)   
--      CONSOLE_RXD         : in  STD_LOGIC ;  -- console RxD (fpga in)     
--      CONSOLE_TXD         : out STD_LOGIC ;  -- console TxD (fpga out)     
--      CONSOLE_USB_PRESENT : in  STD_LOGIC ;  -- console usb present (input, active high)



-- user connector pins. Not used in this project
--con1_05 : out  STD_LOGIC ;
--con1_06 : out  STD_LOGIC ;
--con1_07 : out  STD_LOGIC ;
--con1_08 : out  STD_LOGIC ;
--con1_11 : out  STD_LOGIC ;
--con1_12 : out  STD_LOGIC ;
--con1_13 : out  STD_LOGIC ;
--con1_14 : out  STD_LOGIC ;
--con1_17 : out  STD_LOGIC ;
--con1_18 : out  STD_LOGIC ;
--con1_19 : out  STD_LOGIC ;
--con1_20 : out  STD_LOGIC ;
--con1_23 : out  STD_LOGIC ;
--con1_24 : out  STD_LOGIC ;
--con1_25 : out  STD_LOGIC ;
--con1_26 : out  STD_LOGIC ;
--con1_29 : out  STD_LOGIC ;
--con1_30 : out  STD_LOGIC ;
--con1_31 : out  STD_LOGIC ;
--con1_32 : out  STD_LOGIC ;

--con2_05 : out  STD_LOGIC ;
--con2_06 : out  STD_LOGIC ;
--con2_07 : out  STD_LOGIC ;
--con2_08 : out  STD_LOGIC ;
--con2_11 : out  STD_LOGIC ;
--con2_12 : out  STD_LOGIC ;
--con2_13 : out  STD_LOGIC ;
--con2_14 : out  STD_LOGIC ;
--con2_17 : out  STD_LOGIC ;
--con2_18 : out  STD_LOGIC ;
--con2_19 : out  STD_LOGIC ;
--con2_20 : out  STD_LOGIC ;
--con2_23 : out  STD_LOGIC ;
--con2_24 : out  STD_LOGIC ;
--con2_25 : out  STD_LOGIC ;
--con2_26 : out  STD_LOGIC ;
--con2_29 : out  STD_LOGIC ;
--con2_30 : out  STD_LOGIC ;
--con2_31 : out  STD_LOGIC ;
--con2_32 : out  STD_LOGIC ;


--con4_05 : out  STD_LOGIC ;
--con4_06 : out  STD_LOGIC ;
--con4_07 : out  STD_LOGIC ;
--con4_08 : out  STD_LOGIC ;
--con4_11 : out  STD_LOGIC ;
--con4_12 : out  STD_LOGIC ;
--con4_13 : out  STD_LOGIC ;
--con4_14 : out  STD_LOGIC ;
--con4_17 : out  STD_LOGIC ;
--con4_18 : out  STD_LOGIC ;
--con4_19 : out  STD_LOGIC ;
--con4_20 : out  STD_LOGIC ;
--con4_23 : out  STD_LOGIC ;
--con4_24 : out  STD_LOGIC ;
--con4_25 : out  STD_LOGIC ;
--con4_26 : out  STD_LOGIC ;
--con4_29 : out  STD_LOGIC ;
--con4_30 : out  STD_LOGIC ;
--con4_31 : out  STD_LOGIC ;
--con4_32 : out  STD_LOGIC ;

--con5_05 : out  STD_LOGIC ;
--con5_06 : out  STD_LOGIC ;
--con5_07 : out  STD_LOGIC ;
--con5_08 : out  STD_LOGIC ;
--con5_11 : out  STD_LOGIC ;
--con5_12 : out  STD_LOGIC ;
--con5_13 : out  STD_LOGIC ;
--con5_14 : out  STD_LOGIC ;
--con5_17 : out  STD_LOGIC ;
--con5_18 : out  STD_LOGIC ;
--con5_19 : out  STD_LOGIC ;
--con5_20 : out  STD_LOGIC ;
--con5_23 : out  STD_LOGIC ;
--con5_24 : out  STD_LOGIC ;
--con5_25 : out  STD_LOGIC ;
--con5_26 : out  STD_LOGIC ;
--con5_29 : out  STD_LOGIC ;
--con5_30 : out  STD_LOGIC ;
--con5_31 : out  STD_LOGIC ;
--con5_32 : out  STD_LOGIC ;

--con6_05 : out  STD_LOGIC ;
--con6_06 : out  STD_LOGIC ;
--con6_07 : out  STD_LOGIC ;
--con6_08 : out  STD_LOGIC ;
--con6_11 : out  STD_LOGIC ;
--con6_12 : out  STD_LOGIC ;
--con6_13 : out  STD_LOGIC ;
--con6_14 : out  STD_LOGIC ;
--con6_17 : out  STD_LOGIC ;
--con6_18 : out  STD_LOGIC ;
--con6_19 : out  STD_LOGIC ;
--con6_20 : out  STD_LOGIC ;
--con6_23 : out  STD_LOGIC ;
--con6_24 : out  STD_LOGIC ;
--con6_25 : out  STD_LOGIC ;
--con6_26 : out  STD_LOGIC ;
--con6_29 : out  STD_LOGIC ;
--con6_30 : out  STD_LOGIC ;
--con6_31 : out  STD_LOGIC ;
--con6_32 : out  STD_LOGIC ;

--con7_05 : out  STD_LOGIC ;
--con7_06 : out  STD_LOGIC ;
--con7_07 : out  STD_LOGIC ;
--con7_08 : out  STD_LOGIC ;
--con7_11 : out  STD_LOGIC ;
--con7_12 : out  STD_LOGIC ;
--con7_13 : out  STD_LOGIC ;
--con7_14 : out  STD_LOGIC ;
--con7_17 : out  STD_LOGIC ;
--con7_18 : out  STD_LOGIC ;
--con7_19 : out  STD_LOGIC ;
--con7_20 : out  STD_LOGIC ;
--con7_23 : out  STD_LOGIC ;
--con7_24 : out  STD_LOGIC ;
--con7_25 : out  STD_LOGIC ;
--con7_26 : out  STD_LOGIC ;
--con7_29 : out  STD_LOGIC ;
--con7_30 : out  STD_LOGIC ;
--con7_31 : out  STD_LOGIC ;
--con7_32 : out  STD_LOGIC ;

--con8_05 : out  STD_LOGIC ;
--con8_06 : out  STD_LOGIC ;
--con8_07 : out  STD_LOGIC ;
--con8_08 : out  STD_LOGIC ;
--con8_11 : out  STD_LOGIC ;
--con8_12 : out  STD_LOGIC ;
--con8_13 : out  STD_LOGIC ;
--con8_14 : out  STD_LOGIC ;
--con8_17 : out  STD_LOGIC ;
--con8_18 : out  STD_LOGIC ;
--con8_19 : out  STD_LOGIC ;
--con8_20 : out  STD_LOGIC ;
--con8_23 : out  STD_LOGIC ;
--con8_24 : out  STD_LOGIC ;
--con8_25 : out  STD_LOGIC ;
--con8_26 : out  STD_LOGIC ;
--con8_29 : out  STD_LOGIC ;
--con8_30 : out  STD_LOGIC ;
--con8_31 : out  STD_LOGIC ;
--con8_32 : out  STD_LOGIC ;

--con9_05 : out  STD_LOGIC ;
--con9_06 : out  STD_LOGIC ;
--con9_07 : out  STD_LOGIC ;
--con9_08 : out  STD_LOGIC ;
--con9_11 : out  STD_LOGIC ;
--con9_12 : out  STD_LOGIC ;
--con9_13 : out  STD_LOGIC ;
--con9_14 : out  STD_LOGIC ;
--con9_17 : out  STD_LOGIC ;
--con9_18 : out  STD_LOGIC ;
--con9_19 : out  STD_LOGIC ;
--con9_20 : out  STD_LOGIC ;
--con9_23 : out  STD_LOGIC ;
--con9_24 : out  STD_LOGIC ;
--con9_25 : out  STD_LOGIC ;
--con9_26 : out  STD_LOGIC ;
--con9_29 : out  STD_LOGIC ;
--con9_30 : out  STD_LOGIC ;
--con9_31 : out  STD_LOGIC ;
--con9_32 : out  STD_LOGIC ; 

);
end digit_board_rev0;



 
architecture Behavioral of digit_board_rev0 is




--first hex digit ( LED1 in board SIMPlugIN-DIGIT )
signal 	SEG1A_N	: std_logic;   
signal 	SEG1B_N	: std_logic;
signal 	SEG1C_N	: std_logic;
signal 	SEG1D_N	: std_logic;
signal 	SEG1E_N	: std_logic;
signal 	SEG1F_N	: std_logic;
signal 	SEG1G_N	: std_logic;
signal 	SEG1DP_N	: std_logic;
-- second hex digit ( LED2 in board SIMPlugIN-DIGIT )   
signal 	SEG2A_N	: std_logic;	
signal 	SEG2B_N	: std_logic;
signal 	SEG2C_N	: std_logic;
signal 	SEG2D_N	: std_logic;
signal 	SEG2E_N	: std_logic;
signal 	SEG2F_N	: std_logic;
signal 	SEG2G_N	: std_logic;
signal 	SEG2DP_N	: std_logic;
 --four position switch (SW1 in board SIMPlugIN-DIGIT)
signal	SWSEG0_N	: std_logic;
signal	SWSEG1_N	: std_logic;
signal	SWSEG2_N	: std_logic;
signal	SWSEG3_N	: std_logic;


signal   DLY_CNT							: std_logic_vector( 25 downto 0);
constant	DLY_MAX							: integer range 0 to 32_000_000 := 25_000_000;

signal DIG_CNT								: std_logic_vector(  4 downto 0);

signal seven_segment_display			: std_logic_vector( 7 downto 0);

signal RST		       					: std_logic;
signal CLK		       					: std_logic;


begin


RST		<= 	RESET_POW_ON;

CLK		<=		CLK_25MHZ;

--counter to a frequency slow enough for humans eye to follow
--   increase or decrease constant DLY_MAX to get slower or faster progress of events
--   if necessary increase width of DLY_CNT vector
process(RST,CLK)
begin
	if RST = '1' then
		DLY_CNT <=(others =>'0');
	elsif rising_edge(CLK)then
		if DLY_CNT = DLY_MAX then
			DLY_CNT <=(others =>'0');
		else
			DLY_CNT <= DLY_CNT + 1 ;
		end if;
	end if;
end process;


-- counter to be displayed on seven segment displays
--  counts from 0 to 16 and repeats.
--     values 0 to 15 (hexadecimal 0 to F) are shown as such in seven segments display
--     value 16 (hexadecimal 10)  correspond to only decimal point lit in the display
process(RST,CLK)
begin
	if RST = '1' then
		DIG_CNT <=(others =>'0');
	elsif rising_edge(CLK)then
		if DLY_CNT = DLY_MAX then
			if DIG_CNT = 16 then
				DIG_CNT <=(others =>'0');
			else
				DIG_CNT <= DIG_CNT + 1;
			end if;
		end if;
	end if;
end process;




-- decoding from binary value in counter to seven segment display representation
   -- position of segments in the display
   --         0 (a)
   --        ---  
   --  5 (f)|   | 1 (b)
   --        ---   <- 6 (g)
   --  4 (e)|   | 2 (c)
   --        ---
   --         3 (d)

with DIG_CNT select
seven_segment_display  <= "11000000" when "00000",   --0
						        "11111001" when "00001",   --1
						        "10100100" when "00010",   --2
						        "10110000" when "00011",   --3
						        "10011001" when "00100",   --4
						        "10010010" when "00101",   --5
						        "10000010" when "00110",   --6
						        "11111000" when "00111",   --7
						        "10000000" when "01000",   --8
						        "10010000" when "01001",   --9
						        "10001000" when "01010",   --A
						        "10000011" when "01011",   --B
						        "11000110" when "01100",   --C
						        "10100001" when "01101",   --D
						        "10000110" when "01110",   --E
						        "10001110" when "01111",   --F
						        "01111111" when "10000",   --D.P. (decimal point)
						        "01111111" when others ;  -- D.P. assigned to anomalous counts
                                                    -- that (should) never happen

-- show in both seven segment displays of SIMPlugIN-DIGIT board the value of seven_segment_display count
SEG1A_N					<= seven_segment_display(0); 	
SEG1B_N					<= seven_segment_display(1);	
SEG1C_N					<= seven_segment_display(2);	
SEG1D_N	            <= seven_segment_display(3);
SEG1E_N					<= seven_segment_display(4);	
SEG1F_N	            <= seven_segment_display(5);
SEG1G_N					<= seven_segment_display(6);	
SEG1DP_N             <= seven_segment_display(7);

SEG2A_N					<= seven_segment_display(0);			
SEG2B_N	            <= seven_segment_display(1);
SEG2C_N	            <= seven_segment_display(2);
SEG2D_N	            <= seven_segment_display(3);
SEG2E_N	            <= seven_segment_display(4);
SEG2F_N	            <= seven_segment_display(5);
SEG2G_N	            <= seven_segment_display(6);
SEG2DP_N	            <= seven_segment_display(7);

-- show in the 4 user leds in SIMPlugIN-LX45 board the state of the 4 position switch of SIMPlugIN-DIGIT board						
LED1_N <= SWSEG0_N  ;
LED2_N <= SWSEG1_N  ;
LED3_N <= SWSEG2_N  ;
LED4_N <= SWSEG3_N  ;




-- assign to/from corresponding pins in connector CON3 where SIMPlugIN-DIGIT board is plugged
con3_14 <= SEG1A_N  ;
con3_13 <= SEG1B_N  ;
con3_12 <= SEG1C_N  ;  
con3_08 <= SEG1D_N  ;
con3_07 <= SEG1E_N  ;
con3_05 <= SEG1F_N  ;
con3_06 <= SEG1G_N  ;
con3_11 <= SEG1DP_N ;

con3_26 <= SEG2A_N  ;
con3_25 <= SEG2B_N  ;
con3_24 <= SEG2C_N  ;
con3_20 <= SEG2D_N  ;
con3_19 <= SEG2E_N  ;
con3_17 <= SEG2F_N  ;
con3_18 <= SEG2G_N  ;
con3_23 <= SEG2DP_N ;

SWSEG0_N <= con3_29 ;
SWSEG1_N <= con3_30 ;
SWSEG2_N <= con3_31 ;
SWSEG3_N <= con3_32 ;

                

end Behavioral;

